package de.mdelab.mlstorypatterns.diagram.edit.policies;

import org.eclipse.gef.commands.Command;
import org.eclipse.gmf.runtime.emf.type.core.commands.DestroyElementCommand;
import org.eclipse.gmf.runtime.emf.type.core.requests.CreateRelationshipRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.DestroyElementRequest;
import org.eclipse.gmf.runtime.emf.type.core.requests.ReorientRelationshipRequest;

import de.mdelab.mlstorypatterns.diagram.edit.commands.LinkOrderConstraintCreateCommand;
import de.mdelab.mlstorypatterns.diagram.edit.commands.LinkOrderConstraintReorientCommand;
import de.mdelab.mlstorypatterns.diagram.edit.parts.LinkOrderConstraintEditPart;
import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsElementTypes;

/**
 * @generated
 */
public class StoryPatternLinkItemSemanticEditPolicy extends
		MlstorypatternsBaseItemSemanticEditPolicy {

	/**
	 * @generated
	 */
	public StoryPatternLinkItemSemanticEditPolicy() {
		super(MlstorypatternsElementTypes.StoryPatternLink_4001);
	}

	/**
	 * @generated
	 */
	protected Command getDestroyElementCommand(DestroyElementRequest req) {
		return getGEFWrapper(new DestroyElementCommand(req));
	}

	/**
	 * @generated
	 */
	protected Command getCreateRelationshipCommand(CreateRelationshipRequest req) {
		Command command = req.getTarget() == null ? getStartCreateRelationshipCommand(req)
				: getCompleteCreateRelationshipCommand(req);
		return command != null ? command : super
				.getCreateRelationshipCommand(req);
	}

	/**
	 * @generated
	 */
	protected Command getStartCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (MlstorypatternsElementTypes.LinkOrderConstraint_4004 == req
				.getElementType()) {
			return getGEFWrapper(new LinkOrderConstraintCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * @generated
	 */
	protected Command getCompleteCreateRelationshipCommand(
			CreateRelationshipRequest req) {
		if (MlstorypatternsElementTypes.LinkOrderConstraint_4004 == req
				.getElementType()) {
			return getGEFWrapper(new LinkOrderConstraintCreateCommand(req,
					req.getSource(), req.getTarget()));
		}
		return null;
	}

	/**
	 * Returns command to reorient EClass based link. New link target or source
	 * should be the domain model element associated with this node.
	 * 
	 * @generated
	 */
	protected Command getReorientRelationshipCommand(
			ReorientRelationshipRequest req) {
		switch (getVisualID(req)) {
		case LinkOrderConstraintEditPart.VISUAL_ID:
			return getGEFWrapper(new LinkOrderConstraintReorientCommand(req));
		}
		return super.getReorientRelationshipCommand(req);
	}

}
