package de.mdelab.mlstorypatterns.diagram.part;

import java.util.Collections;
import java.util.List;

import org.eclipse.gef.Tool;
import org.eclipse.gef.palette.PaletteContainer;
import org.eclipse.gef.palette.PaletteGroup;
import org.eclipse.gef.palette.PaletteRoot;
import org.eclipse.gef.palette.ToolEntry;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeConnectionTool;
import org.eclipse.gmf.runtime.diagram.ui.tools.UnspecifiedTypeCreationTool;
import org.eclipse.gmf.runtime.emf.type.core.IElementType;

import de.mdelab.mlstorypatterns.diagram.providers.MlstorypatternsElementTypes;

/**
 * @generated
 */
public class MlstorypatternsPaletteFactory {

	/**
	 * @generated
	 */
	public void fillPalette(PaletteRoot paletteRoot) {
		paletteRoot.add(createStoryPatternTools1Group());
	}

	/**
	 * Creates "Story Pattern Tools" palette tool group
	 * @generated
	 */
	private PaletteContainer createStoryPatternTools1Group() {
		PaletteGroup paletteContainer = new PaletteGroup(
				Messages.StoryPatternTools1Group_title);
		paletteContainer.setId("createStoryPatternTools1Group"); //$NON-NLS-1$
		paletteContainer.add(createStoryPatternObject1CreationTool());
		paletteContainer.add(createAttributeAssignment2CreationTool());
		paletteContainer.add(createStringExpression3CreationTool());
		paletteContainer.add(createStoryPatternLink4CreationTool());
		paletteContainer.add(createStoryPatternContainmentLink5CreationTool());
		paletteContainer.add(createStoryPatternExpressionLink6CreationTool());
		paletteContainer.add(createLinkOrderConstraint7CreationTool());
		paletteContainer.add(createMapEntryLink8CreationTool());
		paletteContainer.add(createMapEntryLinkValueLink9CreationTool());
		paletteContainer.add(createCallActionExpression10CreationTool());
		return paletteContainer;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternObject1CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.StoryPatternObject1CreationTool_title,
				Messages.StoryPatternObject1CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.StoryPatternObject_2003));
		entry.setId("createStoryPatternObject1CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.StoryPatternObject_2003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createAttributeAssignment2CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.AttributeAssignment2CreationTool_title,
				Messages.AttributeAssignment2CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.AttributeAssignment_3002));
		entry.setId("createAttributeAssignment2CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.AttributeAssignment_3002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStringExpression3CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.StringExpression3CreationTool_title,
				Messages.StringExpression3CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.MLStringExpression_3001));
		entry.setId("createStringExpression3CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.MLStringExpression_3001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternLink4CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.StoryPatternLink4CreationTool_title,
				Messages.StoryPatternLink4CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.StoryPatternLink_4001));
		entry.setId("createStoryPatternLink4CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.StoryPatternLink_4001));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternContainmentLink5CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.StoryPatternContainmentLink5CreationTool_title,
				Messages.StoryPatternContainmentLink5CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.ContainmentLink_4002));
		entry.setId("createStoryPatternContainmentLink5CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.ContainmentLink_4002));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createStoryPatternExpressionLink6CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.StoryPatternExpressionLink6CreationTool_title,
				Messages.StoryPatternExpressionLink6CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.ExpressionLink_4003));
		entry.setId("createStoryPatternExpressionLink6CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.ExpressionLink_4003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createLinkOrderConstraint7CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.LinkOrderConstraint7CreationTool_title,
				Messages.LinkOrderConstraint7CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.LinkOrderConstraint_4004));
		entry.setId("createLinkOrderConstraint7CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.LinkOrderConstraint_4004));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMapEntryLink8CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.MapEntryLink8CreationTool_title,
				Messages.MapEntryLink8CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.MapEntryLink_4005));
		entry.setId("createMapEntryLink8CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.MapEntryLink_4005));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createMapEntryLinkValueLink9CreationTool() {
		LinkToolEntry entry = new LinkToolEntry(
				Messages.MapEntryLinkValueLink9CreationTool_title,
				Messages.MapEntryLinkValueLink9CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006));
		entry.setId("createMapEntryLinkValueLink9CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.MapEntryLinkValueTarget_4006));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private ToolEntry createCallActionExpression10CreationTool() {
		NodeToolEntry entry = new NodeToolEntry(
				Messages.CallActionExpression10CreationTool_title,
				Messages.CallActionExpression10CreationTool_desc,
				Collections
						.singletonList(MlstorypatternsElementTypes.CallActionExpression_3003));
		entry.setId("createCallActionExpression10CreationTool"); //$NON-NLS-1$
		entry.setSmallIcon(MlstorypatternsElementTypes
				.getImageDescriptor(MlstorypatternsElementTypes.CallActionExpression_3003));
		entry.setLargeIcon(entry.getSmallIcon());
		return entry;
	}

	/**
	 * @generated
	 */
	private static class NodeToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> elementTypes;

		/**
		 * @generated
		 */
		private NodeToolEntry(String title, String description,
				List<IElementType> elementTypes) {
			super(title, description, null, null);
			this.elementTypes = elementTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeCreationTool(elementTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}

	/**
	 * @generated
	 */
	private static class LinkToolEntry extends ToolEntry {

		/**
		 * @generated
		 */
		private final List<IElementType> relationshipTypes;

		/**
		 * @generated
		 */
		private LinkToolEntry(String title, String description,
				List<IElementType> relationshipTypes) {
			super(title, description, null, null);
			this.relationshipTypes = relationshipTypes;
		}

		/**
		 * @generated
		 */
		public Tool createTool() {
			Tool tool = new UnspecifiedTypeConnectionTool(relationshipTypes);
			tool.setProperties(getToolProperties());
			return tool;
		}
	}
}
